//
//  ViewController.m
//  libt2udemo
//
//  Created by zxy on 16/8/4.
//  Copyright © 2016年 vveye. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController
@synthesize view_main;

@synthesize view_devinfo;
@synthesize tf_dev_uuid;
@synthesize button_search_dev;
@synthesize tf_dev_port;
@synthesize tf_local_port;
@synthesize button_web_test;
@synthesize tf_svraddr;
@synthesize tf_svrport;
@synthesize tf_svr_key;
@synthesize tf_t2upass;
@synthesize button_p2p;
@synthesize tv_log;


@synthesize view_spinner;


@synthesize view_devlist;
@synthesize tableview_devlist;


@synthesize view_devweb;
@synthesize webview_dev;

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    bRunning=false;
    m_dev_array = [NSMutableArray new];
    
    tableview_devlist.delegate = self;
    tableview_devlist.dataSource = self;
    
    tf_dev_uuid.delegate = self;
    tf_dev_port.delegate = self;
    tf_local_port.delegate =self;
    tf_svraddr.delegate = self;
    tf_svrport.delegate = self;
    tf_svr_key.delegate = self;
    tf_t2upass.delegate = self;
    webview_dev.delegate = self;
    
}


- (BOOL)textFieldShouldReturn:(UITextField *)textField{
    [textField resignFirstResponder];
    return  YES;
}
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(void)process_search_result:(NSString*)string
{
    NSString *strdev=string;
    NSString *struuid;
    NSString *strip;
    [m_dev_array removeAllObjects];
    if (strdev != nil && strdev.length > 0) {
        NSArray *aArray = [strdev componentsSeparatedByString:@"\n"];
        for (NSString* devstr in aArray) {
            if (devstr != nil && devstr.length > 0) {
                //NSLog(@"devinfo:%@",devstr);
                NSRange range0 = [devstr rangeOfString:@"uuid="];
                NSRange range1 = [devstr rangeOfString:@",ip="];
                if (range0.length > 0 && range1.length > 0) {
                    unsigned long location0 = range0.location + range0.length;
                    unsigned long location1 = range1.location + range1.length;
                    struuid = [devstr substringWithRange:NSMakeRange(location0, range1.location - location0)];
                    strip = [devstr substringFromIndex:location1];
                    if (struuid != nil && strip != nil) {
                        item_search* cur_item = [item_search new];
                        cur_item.m_devid = struuid;
                        cur_item.m_ip = strip;
                        [m_dev_array addObject:cur_item];
                    }
                }
            }
            
        }
    }
    [tableview_devlist reloadData];
    view_spinner.hidden = true;
    view_devlist.hidden = false;
    [view_main bringSubviewToFront:view_devlist];
}

//搜索局域网中的p2p设备
//seach p2p device in local network
-(void)start_search
{
    char buff[1024] = {0};
    NSString* m_str_devlist = @"";
    int res = t2u_search(buff,sizeof(buff));
    if (res > 0) {
        m_str_devlist = [NSString stringWithUTF8String:buff];
    }
    else{
        m_str_devlist = @"";
    }
    
    [self performSelectorOnMainThread:@selector(process_search_result:) withObject:m_str_devlist waitUntilDone:YES];
}

- (IBAction)button_search_dev_click:(id)sender {
    view_spinner.hidden = false;
    [view_main bringSubviewToFront:view_spinner];
    [NSThread detachNewThreadSelector:@selector(start_search) toTarget:self withObject:nil];
}

- (IBAction)button_devlist_exit_click:(id)sender {
    view_devlist.hidden = true;
}

//映射成功后，通过p2p通道打开设备端的网页
//open the web page of device after created the p2p tunnel
- (void)loadWebPageWithString
{
    [[NSURLCache sharedURLCache] removeAllCachedResponses];
    NSString* strurl = [NSString stringWithFormat:@"http://admin:admin@127.0.0.1:8080"];
    NSURL *url = [NSURL URLWithString:strurl];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    [webview_dev loadRequest:request];
}
- (IBAction)button_devweb_click:(id)sender {

    view_devweb.hidden = false;
    [view_main bringSubviewToFront:view_devweb];
    [self loadWebPageWithString];
}

//更新按钮状态
//update the status of button
-(void)on_update_status_final
{
    button_web_test.hidden = true;
    button_p2p.enabled = true;
    button_search_dev.hidden = false;
    [button_p2p setBackgroundColor:[UIColor blueColor]];
    [button_p2p setTitle:@"Create P2P tunnel" forState:UIControlStateNormal];
}
-(void)on_update_status
{
    char str[1024];
    NSString *strlog = @"";
    if (qret == 1) {
        button_search_dev.hidden = true;
        button_p2p.enabled = true;
        button_web_test.hidden = false;
        [button_p2p setBackgroundColor:[UIColor blueColor]];
        [button_p2p setTitle:@"Close P2P tunnel" forState:UIControlStateNormal];
        
        if(strlen(stat.ip) > 0 && strcmp(stat.ip, "0.0.0.0") != 0 && strcmp(stat.ip, "127.0.0.1") != 0)
        {
            sprintf(str, "status: 1 (successful) P2P Addr：%s:%d Version: %d Proxy: %d",
                    stat.ip, stat.port, stat.remote_version, stat.proxy);
        }
        else
            sprintf(str, "status: 1 (successful) P2P Addr：%s|%d Version: %d Proxy: %d",
                     stat.ip6, stat.port, stat.remote_version, stat.proxy);
    }
    else{
        button_search_dev.hidden = false;
        button_p2p.enabled = false;
        button_web_test.hidden = true;
        
        switch(qret)
        {
            case 0:
                sprintf(str, "status: %d (out of time)", qret);
                break;
            case -1:
                sprintf(str, "status: %d (uuid is not exists!", qret);
                break;
            case -2:
                sprintf(str, "status: %d (Create p2p connection failed!)", qret);
                break;
            case -3:
                sprintf(str, "status: %d (P2P connection interrupted!)", qret);
                break;
            case -4:
                sprintf(str, "status: %d (The device is offline!)", qret);
                break;
            case -5:
                sprintf(str, "status: %d (P2P password incorrect!)", qret);
                break;
            default:
                sprintf(str, "status: %d (unknown!)", qret);

        }
        
    }
    
    strlog = [[NSString alloc]initWithUTF8String:str];
    tv_log.text = strlog;
    
}

//P2P通道线程，创建p2p通道并在退出时销毁
//注：本例中，只创建一个P2P通道，因此在线程退出时调用了t2u_exit，
//   实际应用中，t2u_init只需要在应用启动时调用一次，t2u_exit在应用结束时调用一次。
//   这两个接口不需要在每次创建P2P通道时都调用。
//Thread for create the P2P tunnel.
//Note: just call t2u_init only once after opened the application, and just call t2u_exit only once before exit the application.
-(void)start_load
{
    int stop=0;
    
    while(bRunning == true)
    {
        ret = t2u_status();
        if (ret > 0)
        {
            if (m_addport == 0)
            {
                if(m_t2u_pass == nil || m_t2u_pass.length <= 0)
                {
                    aret = t2u_add_port((char*)[m_dev_uuid UTF8String], m_dev_port, m_local_port);
                }
                else
                {
                    aret = t2u_add_port_v3((char*)[m_dev_uuid UTF8String],(char*)[m_t2u_pass UTF8String], "127.0.0.1", m_dev_port, m_local_port);
                }
                
                if (aret < 0)
                {
                    stop = 1;
                }
                else
                {
                    m_addport = 1;
                    conn_time = 0;
                   // NSLog(@"Creatting P2P tunnel...");
                }
            }
            else
            {
                qret = t2u_port_status(m_local_port, &stat);
                if (qret == 1)
                {
                    conn_time = 0;
                }
                else if(qret == 0)
                {
                    conn_time++;
                    if (conn_time >= 20) {
                        stop = 1;
                    }
                    else
                        sleep(1);
                }
                else
                {
                    stop = 1;
                }
                if (m_prestatus != qret) {
                    [self performSelectorOnMainThread:@selector(on_update_status) withObject:nil waitUntilDone:YES];
                }
                m_prestatus = qret;
                
                if (stop == 1)
                {
                    
                    bRunning = false;
                }
            }
            
        }
        else
            sleep(1);
    }
    if (aret > 0) {
        t2u_del_port(aret);
        aret = 0;
    }
    
    t2u_exit();
    [self performSelectorOnMainThread:@selector(on_update_status_final) withObject:nil waitUntilDone:YES];
}

//初始化，并开启用于创建P2P通道的线程。
//init libt2u, open the thread for create p2p tunnel.
- (IBAction)button_p2p_tunnel_click:(id)sender {
    
    [tf_dev_uuid resignFirstResponder];
    [tf_dev_port resignFirstResponder];
    [tf_local_port resignFirstResponder];
    [tf_svraddr resignFirstResponder];
    [tf_svrport resignFirstResponder];
    [tf_svr_key resignFirstResponder];
    [tf_t2upass resignFirstResponder];;
    tv_log.text = @"";
    
    m_dev_uuid = [tf_dev_uuid.text stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceCharacterSet]];
    m_dev_port = [tf_dev_port.text intValue];
    m_local_port = [tf_local_port.text intValue];
    
    m_svr_addr = [[tf_svraddr.text lowercaseString]stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceCharacterSet]];
    m_svr_port = [tf_svrport.text intValue];
    m_svr_key = [tf_svr_key.text stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceCharacterSet]];
    
    m_t2u_pass = [tf_t2upass.text stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceCharacterSet]];
    if (m_dev_uuid == nil || m_dev_uuid.length <= 0) {
        NSLog(@"Please input UUID!");
        return;
    }
    if (bRunning == false) {
        m_prestatus = -99;
        bRunning = true;
        if (m_svr_key == NULL || m_svr_key.length <= 0) {
            t2u_init((char*)[m_svr_addr UTF8String], m_svr_port, NULL);
        }
        else
            t2u_init((char*)[m_svr_addr UTF8String], m_svr_port, (char*)[m_svr_key UTF8String]);
        
        button_search_dev.hidden = true;
        button_p2p.enabled = false;
        [button_p2p setBackgroundColor:[UIColor lightGrayColor]];
        [button_p2p setTitle:@"Creating..." forState:UIControlStateNormal];
        
        m_addport = 0;
        NSLog(@"Connecting to the server ...");
        [NSThread detachNewThreadSelector:@selector(start_load) toTarget:self withObject:nil];
    }
    else{
        bRunning = false;
        button_web_test.hidden = true;
        button_p2p.enabled = true;
        button_search_dev.hidden = false;
        [button_p2p setBackgroundColor:[UIColor blueColor]];
        [button_p2p setTitle:@"Create P2P tunnel" forState:UIControlStateNormal];
    }

}

- (IBAction)button_devweb_exit:(id)sender {
    view_devweb.hidden = true;
}
-(void)on_dev_select:(int)pos
{
    item_search* cur_item = [m_dev_array objectAtIndex:pos];
    tf_dev_uuid.text = cur_item.m_devid;
    view_devlist.hidden = true;
}
/////////
- (void)webViewDidStartLoad:(UIWebView *)webView
{
    NSLog(@"webViewDidStartLoad");
}
-(void)webViewDidFinishLoad:(UIWebView *)webView
{
    NSLog(@"webViewDidFinishLoad");
    
}
- (void)webView:(UIWebView *)webView didFailLoadWithError:(NSError *)error
{
    NSLog(@"webViewDidFinishLoad, didFailLoadWithError");
}
//////////////////
- (CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section{
    
    return 0;
}

- (UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section{
    
    return NULL;
}


- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    
    return 40;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return m_dev_array.count;
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    static NSString *CellIdentifier_dev = @"TableViewCell_dev";
    
    TableViewCell_dev* Cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier_dev];
    if (Cell == nil) {
        Cell = [[[NSBundle mainBundle] loadNibNamed:CellIdentifier_dev owner:self options:nil] lastObject];
    }
    
    item_search* cur_item = [m_dev_array objectAtIndex:indexPath.row];
    [Cell config_cell:cur_item.m_devid pos:indexPath.row];
    
    Cell.delgate = self;
    return Cell;
}
- (NSIndexPath *)tableView:(UITableView *)tableView willSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    return  nil;
}
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    [tableView deselectRowAtIndexPath:indexPath animated:YES];

}

@end
